All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.sas.prompts
Interface PromptValuesInterface

All Known Implementing Classes:
  PromptValues

    @SASScope(value="ALL")
    public interface PromptValuesInterface

Interface for classes which hold sets of prompt values.

Method Summary
`abstract void` | `acceptPromptValuesVisitor(PromptValuesVisitorInterface visitor)` Accept method for visitor object (see visitor pattern) which passes the visitor on to any delegate PromptValues objects.
`abstract void` | `addPromptValueChangeListener(PromptValueChangeListener listener)` Adds a listener so that changes to prompt values can be monitored.
`abstract void` | `addPromptValuesDelegate(PromptValuesInterface promptValues)` Adds another PromptValues object as a delegate of this PromptValues object.
`abstract void` | `clearPromptValue(PromptDefinitionInterface promptDefinition)` Clears the prompt value such that isPromptValueSet returns false.
`abstract void` | `clearPromptValuesDelegates()` Removes all previously added delegates.
`abstract PromptValuesInterface` | `findPromptValuesForPromptDefinition(PromptDefinitionInterface promptDefinition)` Recursively finds the first PromptValues object which holds the PromptGroup which contains the specified PromptDefinition.
`abstract com.sas.util.MutableUserInfoInterface` | `getMutableUserInfo()` Returns a user info object which can be read and/or modified.
`abstract PromptDefinitionInterface` | `getPromptDefinition(java.lang.String promptName, boolean recursive)` Returns the PromptDefinitionInterface for the given prompt name in the PromptGroup held by the PromptValuesInterface.
`abstract java.util.List` | `getPromptDefinitionCombinations(PromptDefinitionInterface promptDefinition)` Returns a List of PromptDefinitionInterfaces which are combined with the specified prompt.
`abstract PromptGroupInterface` | `getPromptGroup()` Returns the PromptGroupInterface that this is attached to.
`abstract java.lang.Object` | `getPromptValue(PromptDefinitionInterface promptDefinition)` Returns the current value of the prompt.
`abstract java.util.Date` | `getPromptValueAsDate(PromptDefinitionInterface promptDefinition)` Returns the current value of the specified prompt definition.
`abstract double` | `getPromptValueAsDouble(PromptDefinitionInterface promptDefinition)` Returns the current value of the specified prompt definition.
`abstract int` | `getPromptValueAsInt(PromptDefinitionInterface promptDefinition)` Returns the current value of the specified prompt definition.
`abstract java.util.List` | `getPromptValueAsList(PromptDefinitionInterface promptDefinition)` Returns the current value of the specified prompt definition.
`abstract java.lang.String` | `getPromptValueAsString(PromptDefinitionInterface promptDefinition)` Returns the current value of the specified prompt definition.
`abstract java.lang.String` | `getPromptValueAsString(PromptDefinitionInterface promptDefinition, java.util.Locale locale)` Returns the specified prompt value as a string formatted in the specified locale.
`abstract PromptValueChangeListener[]` | `getPromptValueChangeListeners()` Returns an array of all the `PromptValueChangeListener`s added to this PromptValues with addPromptValuesChangeListener().
`abstract java.util.Map` | `getPromptValues()` Returns the values of all prompts stored in this PromptValueInterface.
`abstract java.util.Map` | `getPromptValues(PromptGroupInterface promptGroup, boolean recursive, boolean includeDefaultAndStickyValues)` Returns the values for the specified prompt definition group, possibly recursing into subgroups.
`abstract java.util.List` | `getPromptValuesDelegates()` Returns a list of delegates for the PromptValues.
`abstract void` | `init(java.util.Map options)` When called, this method will check all the definitions that have a value provider that implement the ValueProviderInitializationInterface and will call initialize method on each value provider with the options passed in.
`abstract boolean` | `isAllPromptValuesValid()` Returns whether all the prompts contain valid values.
`abstract boolean` | `isAllRequiredPromptsValid()` Returns true if all the required prompts contain a value and the value is valid, false otherwise
`abstract boolean` | `isPromptValueAvailable(PromptDefinitionInterface promptDefinition)` Returns true is the prompt has either a value set, a sticky value or a default value, false otherwise.
`abstract boolean` | `isPromptValueSet(PromptDefinitionInterface promptDefinition)` Returns whether the prompt value is actually set.
`abstract boolean` | `isPromptValueValid(PromptDefinitionInterface promptDefinition)` Returns whether the prompt value is currently valid or not.
`abstract void` | `removePromptValueChangeListener(PromptValueChangeListener listener)` Removes a listener from monitoring prompt value changes.
`abstract void` | `removePromptValuesDelegate(PromptValuesInterface promptValues)` Removes a PromptValues delegate previously added with addPromptValuesDelegate.
`abstract void` | `setInitParameter(java.lang.String key, java.lang.Object value)` When called, this method will check all the definitions that have a value provider that implement the ValueProviderInitializationInterface and will call initialize method on each value provider with the key-value pair passed in.
`abstract void` | `setPromptGroup(PromptGroupInterface promptGroup, boolean clearValuesNotInGroup)` Sets the PromptGroupInterface that this PromptValues is attached to.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, java.util.Date value)` Sets the current value of the PromptDefinitionInterface to the specified Date.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, double value)` Sets the current value of the PromptDefinitionInterface to the specified int.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, java.util.List value)` Sets the current value of the PromptDefinitionInterface to the specified List.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, java.lang.Object value)` Sets the current value of the prompt.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, java.lang.Object value, java.util.Locale inputLocale)` Sets the current value of the PromptDefinitionInterface.
`abstract void` | `setPromptValue(PromptDefinitionInterface promptDefinition, java.lang.String value)` Sets the current value of the PromptDefinitionInterface to the specified String.
`abstract void` | `setPromptValues(java.util.Map definitionToValueMap, java.util.Locale inputLocale)` Sets one or more of prompt values at the same time.

Method Detail

### init

    void init(java.util.Map options)

  When called, this method will check all the definitions that have a value provider that implement the ValueProviderInitializationInterface and will call initialize method on each value provider with the options passed in.

  Parameters:
    `options` - Map a map of options, see the ValueProviderInitializationInterface for more details

### setInitParameter

    void setInitParameter(java.lang.String key,
                          java.lang.Object value)

  When called, this method will check all the definitions that have a value provider that implement the ValueProviderInitializationInterface and will call initialize method on each value provider with the key-value pair passed in. The key-value pairs are not held onto, so if this method is called more then once, the initialize method on the value providers will only get passed the current key-value pair, so if more then one param is needed, either use the init(Map) method or the value provider needs to handle initialize being called more then once.

  Parameters:
    `key` -
    `value` -

### getPromptValue

    java.lang.Object getPromptValue(PromptDefinitionInterface promptDefinition)
                                    throws PromptValueNotFoundException

  Returns the current value of the prompt. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### getPromptValueAsDate

    java.util.Date getPromptValueAsDate(PromptDefinitionInterface promptDefinition)
                                        throws PromptValueNotFoundException

  Returns the current value of the specified prompt definition. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available. The returned value will be cast to a Date. If the value is not a Date, a ClassCastException will be thrown.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### getPromptValueAsDouble

    double getPromptValueAsDouble(PromptDefinitionInterface promptDefinition)
                                  throws PromptValueNotFoundException

  Returns the current value of the specified prompt definition. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available. The returned value will be cast to a Double and then converted to a double. If the value is not a Double, a ClassCastException will be thrown.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### getPromptValueAsInt

    int getPromptValueAsInt(PromptDefinitionInterface promptDefinition)
                            throws PromptValueNotFoundException

  Returns the current value of the specified prompt definition. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available. The returned value will be cast to an Integer and then converted to an int. If the value is not an Integer, a ClassCastException will be thrown.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### getPromptValueAsList

    java.util.List getPromptValueAsList(PromptDefinitionInterface promptDefinition)
                                        throws PromptValueNotFoundException

  Returns the current value of the specified prompt definition. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available. If the value is a List, it will be returned directly. If it is not a List, a List will be created and the value will be added to the List before the list is returned.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### getPromptValueAsString

    java.lang.String getPromptValueAsString(PromptDefinitionInterface promptDefinition)
                                            throws PromptValueNotFoundException

  Returns the current value of the specified prompt definition. If no value is set, a default from the sticky defaults or the PromptDefinitionInterface will be returned if available. The returned value will be cast to a String. If the value is not a String, a ClassCastException will be thrown.

  Parameters:
    `promptDefinition` - The prompt definition to return the value for
  Returns:
    The current value of the prompt
  Throws:
    `PromptValueNotFoundException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        java.lang.Object value)
                        throws InvalidPromptValueException

  Sets the current value of the prompt.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
  Throws:
    `InvalidPromptValueException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        double value)
                        throws InvalidPromptValueException

  Sets the current value of the PromptDefinitionInterface to the specified int.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
  Throws:
    `InvalidPromptValueException` - public void setPromptValue( PromptDefinitionInterface promptDefinition, int value ) throws InvalidPromptValueException; /** Sets the current value of the PromptDefinitionInterface to the specified double.
    `InvalidPromptValueException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        java.util.Date value)
                        throws InvalidPromptValueException

  Sets the current value of the PromptDefinitionInterface to the specified Date.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
  Throws:
    `InvalidPromptValueException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        java.util.List value)
                        throws InvalidPromptValueException

  Sets the current value of the PromptDefinitionInterface to the specified List.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
  Throws:
    `InvalidPromptValueException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        java.lang.String value)
                        throws InvalidPromptValueException

  Sets the current value of the PromptDefinitionInterface to the specified String.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
  Throws:
    `InvalidPromptValueException`

### setPromptValue

    void setPromptValue(PromptDefinitionInterface promptDefinition,
                        java.lang.Object value,
                        java.util.Locale inputLocale)
                        throws InvalidPromptValueException

  Sets the current value of the PromptDefinitionInterface.

  Parameters:
    `promptDefinition` - The prompt definition to set the value of
    `value` - The new value of the prompt.
    `inputLocale` - The locale that the value was entered in
  Throws:
    `InvalidPromptValueException`

### setPromptValues

    void setPromptValues(java.util.Map definitionToValueMap,
                         java.util.Locale inputLocale)
                         throws InvalidPromptValueException

  Sets one or more of prompt values at the same time.

  Parameters:
    `definitionToValueMap` - A Map containing the names and values of the prompts to set the value of.
    `inputLocale` - The locale that the values were entered in.
  Throws:
    `InvalidPromptValueException`

### getPromptValueAsString

    java.lang.String getPromptValueAsString(PromptDefinitionInterface promptDefinition,
                                            java.util.Locale locale)
                                            throws PromptValueNotFoundException

  Returns the specified prompt value as a string formatted in the specified locale.

  Parameters:
    `promptDefinition` - The prompt to return the value of
    `locale` - Locale The locale to format the value for
  Returns:
    the specified prompt value as a string formatted in the specified locale.
  Throws:
    `PromptValueNotFoundException`

### isPromptValueSet

    boolean isPromptValueSet(PromptDefinitionInterface promptDefinition)

  Returns whether the prompt value is actually set. This is useful since getPromptValue may return a default even though no value is set.

  Parameters:
    `promptDefinition` - PromptDefinitionInterface
  Returns:
    whether the prompt value is actually set

### isPromptValueAvailable

    boolean isPromptValueAvailable(PromptDefinitionInterface promptDefinition)

  Returns true is the prompt has either a value set, a sticky value or a default value, false otherwise.

  Parameters:
    `promptDefinition` - The prompt to query whether its value is available
  Returns:
    true is a value is availabel, false otherwise

### clearPromptValue

    void clearPromptValue(PromptDefinitionInterface promptDefinition)

  Clears the prompt value such that isPromptValueSet returns false. getPromptValue may still return a value due to sticky defaults or a default value set in the prompt definition.

  Parameters:
    `promptDefinition` - The prompt to clear the value of

### isPromptValueValid

    boolean isPromptValueValid(PromptDefinitionInterface promptDefinition)

  Returns whether the prompt value is currently valid or not.

  Parameters:
    `promptDefinition` - The prompt to determine if the value is valid
  Returns:
    whether the prompt value is currently valid or not.

### isAllPromptValuesValid

    boolean isAllPromptValuesValid()

  Returns whether all the prompts contain valid values.

  Returns:
    whether all the prompts contain valid values.

### isAllRequiredPromptsValid

    boolean isAllRequiredPromptsValid()

  Returns true if all the required prompts contain a value and the value is valid, false otherwise

  Returns:
    true is the required prompt are valid

### getPromptValues

    java.util.Map getPromptValues(PromptGroupInterface promptGroup,
                                  boolean recursive,
                                  boolean includeDefaultAndStickyValues)

  Returns the values for the specified prompt definition group, possibly recursing into subgroups. Only values associated with the prompts defined in the group will be included in the resulting Map.

  Parameters:
    `promptGroup` - The group to get values for
    `recursive` - Whether to return values from subgroups of the group passed in
    `includeDefaultAndStickyValues` - Whether to result default and sticky value or just values that have been set
  Returns:
    A Map of PromptDefinitionInterfaces to objects which represent the current values of the prompts

### getPromptValues

    java.util.Map getPromptValues()

  Returns the values of all prompts stored in this PromptValueInterface. TODO: Do we need a parameter like includeDefaultAndStickyValues?

  Returns:
    the values of all prompts stored in this PromptValueInterface.

### getPromptGroup

    PromptGroupInterface getPromptGroup()

  Returns the PromptGroupInterface that this is attached to.

  Returns:
    The PromptGroupInterface that the prompt values are for

### setPromptGroup

    void setPromptGroup(PromptGroupInterface promptGroup,
                        boolean clearValuesNotInGroup)

  Sets the PromptGroupInterface that this PromptValues is attached to. Optionally, setPromptGroup will clear any prompt values which have already been set on the PromptValues but are not in the group passed in.

  Parameters:
    `promptGroup` - The PromptGroupInterface that the prompt values are for
    `clearValuesNotInGroup` - Whether to clear values not in the group set on the PromptValues

### addPromptValueChangeListener

    void addPromptValueChangeListener(PromptValueChangeListener listener)

  Adds a listener so that changes to prompt values can be monitored. Events should be sent when values are changed or cleared. Notifications are not sent for implicit changes to values by changing defaults or sticky values. TODO: Can a listener be added more than once?

  Parameters:
    `The` - listener to call when a value change occurs

### removePromptValueChangeListener

    void removePromptValueChangeListener(PromptValueChangeListener listener)

  Removes a listener from monitoring prompt value changes. If the listener is not registered, no action is taken.

  Parameters:
    `The` - listener to stop calling when a value change occurs

### getPromptValueChangeListeners

    PromptValueChangeListener[] getPromptValueChangeListeners()

  Returns an array of all the `PromptValueChangeListener`s added to this PromptValues with addPromptValuesChangeListener().

  Returns:
    all of the `PromptValueChangeListener`s added or an empty array if no listeners have been added

### getPromptDefinition

    PromptDefinitionInterface getPromptDefinition(java.lang.String promptName,
                                                  boolean recursive)

  Returns the PromptDefinitionInterface for the given prompt name in the PromptGroup held by the PromptValuesInterface. Note that only the first prompt found with the given name will be returned. The prompt model does not require that prompt names be unique, so there may be any number of prompts with the same name.

  Parameters:
    `promptName` - The name of the prompt to search for
    `recursive` - Whether to search in subgroups of the main prompt group
  Returns:
    PromptDefinitionInterface

### clearPromptValuesDelegates

    void clearPromptValuesDelegates()

  Removes all previously added delegates.

### addPromptValuesDelegate

    void addPromptValuesDelegate(PromptValuesInterface promptValues)

  Adds another PromptValues object as a delegate of this PromptValues object. Values for PromptDefinitions of the delegate can be set/retrieved on the base or delegate PromptValues object. This allows for chaining and grouping of prompts from different sources while keeping their values stored in separate PromptValuesInterface implementations.

  Parameters:
    `promptValues` - The delegate to add

### removePromptValuesDelegate

    void removePromptValuesDelegate(PromptValuesInterface promptValues)

  Removes a PromptValues delegate previously added with addPromptValuesDelegate.

  Parameters:
    `promptValues` - The delegate to remove

### getPromptValuesDelegates

    java.util.List getPromptValuesDelegates()

  Returns a list of delegates for the PromptValues. null or an empty list will be returned if there are no delegates.

  Returns:
    a list of delegates for the PromptValues.

### findPromptValuesForPromptDefinition

    PromptValuesInterface findPromptValuesForPromptDefinition(PromptDefinitionInterface promptDefinition)

  Recursively finds the first PromptValues object which holds the PromptGroup which contains the specified PromptDefinition. The returned PromptValues will either be the PromptValues this method is called on, a delegate, a descendent to a delegate, or null.

  Parameters:
    `promptDefinition` - The PromptDefinitionInterface to find the PromptValues for.
  Returns:
    the first PromptValues object which holds the PromptGroup which contains the specified prompt

### acceptPromptValuesVisitor

    void acceptPromptValuesVisitor(PromptValuesVisitorInterface visitor)

  Accept method for visitor object (see visitor pattern) which passes the visitor on to any delegate PromptValues objects.

  Parameters:
    `visitor` - The visitor to call for each delegate

### getMutableUserInfo

    com.sas.util.MutableUserInfoInterface getMutableUserInfo()

  Returns a user info object which can be read and/or modified.

  Returns:
    a user info object which can be read and/or modified.

### getPromptDefinitionCombinations

    java.util.List getPromptDefinitionCombinations(PromptDefinitionInterface promptDefinition)

  Returns a List of PromptDefinitionInterfaces which are combined with the specified prompt.

  Parameters:
    `promptDefinition` - The prompt to return combinations for
  Returns:
    a List of PromptDefinitionInterfaces which are combined with the specified PromptDefinitionInterface.

All Libraries | This Library | Package | Class | Use | Tree | Deprecated | Index | Grand Index | Help
|  | Components |
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2009 SAS Institute Inc. All Rights Reserved.